Skip to main content

JsPlumb Svelte

JsPlumb offers integration with Svelte. The minimum required version is 3.55.0, but we recommend using Svelte 4. We have not yet tested our Svelte integration with Svelte 5.

Imports​

"dependencies":{
"@jsplumbtoolkit/browser-ui-svelte":"6.81.0"
}

Quick start​

The Toolkit's Svelte integration offers a wrapper around the Surface component. Let's take a quick look at how you'd use one:

<script>

import { SurfaceComponent,
ControlsComponent,
MiniviewComponent } from '@jsplumbtoolkit/browser-ui-svelte'

const data = {
nodes:[
{ id:"1", label:"1", left:50, top:50},
{ id:"2", label:"TWO", left:250, top:250}
],
edges:[
{ source:"1", target:"2" }
]
}

</script>

<div>
<SurfaceComponent data={data}>
<ControlsComponent/>
<MiniviewComponent/>
</SurfaceComponent>
</div>

In the above example the only prop we set on the SurfaceComponent was data, meaning the component uses a default Absolute layout and a default Svelte component for rendering nodes. The SurfaceComponent, though, is highly configurable, mainly through its viewOptions and renderOptions props. Here's the same example from before but with a few more things configured:

<script>

import { SurfaceComponent,
ControlsComponent,
MiniviewComponent } from '@jsplumbtoolkit/browser-ui-svelte'

import { ForceDirectedLayout } from "@jsplumbtoolkit/browser-ui"

import MyNodeComponent from "./MyNodeComponent.svelte"

const data = {
nodes:[
{ id:"1", label:"1", left:50, top:50},
{ id:"2", label:"TWO", left:250, top:250}
],
edges:[
{ source:"1", target:"2" }
]
}

const view = {
nodes:{
default:{
component:MyNodeComponent
}
}
}

const renderOptions = {
layout:{
type:ForceDirectedLayout.type
},
grid:{
size:{
w:50, h:50
}
}
}

</script>

<div>
<SurfaceComponent data={data} renderOptions={renderOptions} viewOptions={view}>
<ControlsComponent/>
<MiniviewComponent/>
</SurfaceComponent>
</div>


Rendering Nodes and Groups​

At the core of your UI will be a SurfaceComponent, which provides the canvas onto which nodes, groups and edges are drawn. In the Quickstart section above we show a couple of examples of the SurfaceComponent in action.

Each node or group in your UI is rendered as an individual component. In the first example above, we rely on JsPlumb's default Svelte component to render each node, but in the second we provide a component ourselves, although its quite simple. In a real world app your components will likely be more complex. As an example, consider the component we use to render nodes in the Flowchart Builder:

<script>

import { anchorPositions } from "../constants"

import { ShapeComponent } from "@jsplumbtoolkit/browser-ui-svelte"

export let data;
export let toolkit;
export let surface;
export let vertex;

function removeNode() {
toolkit.removeNode(vertex)
}

</script>

<div style="color:{data.textColor}" class="flowchart-object" data-jtk-target="true">

<ShapeComponent surface={surface} vertex={vertex} data={data} showLabels="true" labelProperty="text"/>

{#each anchorPositions as anchor}
<div class="jtk-connect jtk-connect-{anchor.id}"
data-jtk-anchor-x={anchor.x}
data-jtk-anchor-y={anchor.y}
data-jtk-orientation-x={anchor.ox}
data-jtk-orientation-y={anchor.oy}
data-jtk-source="true"></div>
{/each}

<div class="node-delete node-action delete" on:click={() => removeNode()}></div>
</div>

The contents of the component used to render each node/group are entirely up to you.

Mapping types to components​

The viewOptions prop is used to map node/group types to components, and to certain behaviours. For instance, this is the nodes section of the viewOptions for the flowchart builder starter app:


import { DEFAULT, newInstance } from "@jsplumbtoolkit/browser-ui"
import NodeComponent from "./NodeComponent.svelte"

const view = {
nodes:{
[DEFAULT]:{
component:NodeComponent,
// connections to/from this node can exist at any of the given anchorPositions
anchorPositions,
// node can support any number of connections.
maxConnections: -1,
events: {
[EVENT_TAP]: ({toolkit, renderer, e, obj}) => {
renderer.stopEditingPath()
// if zero nodes currently selected, or the shift key wasnt pressed, make this node the only one in the selection.
if (toolkit.getSelection()._nodes.length < 1 || e.shiftKey !== true) {
toolkit.setSelection(obj)
} else {
// if multiple nodes already selected, or shift was pressed, add this node to the current selection.
toolkit.addToSelection(obj)
}
}
}
}
}
}

To map a node/group type to a component, you're expected to provide a component that takes four props:

<script>

// the backing data for the vertex
export let data

// the vertex itself (a node/group)
export let vertex

// the underlying JsPlumb toolkit
export let toolkit

// the Surface that is rendering this vertex
export let surface

</script>

Injecting props​

You can pass props in to the components used to render your vertices by configuring an injector in a the render options:

const renderOptions = {
...
inject:(o:Node|Group) => {

return {
some:"props",
number:23
}
}
...
}

Prior to a node/group being rendered, the injector will be invoked with the mode object, and is expected to return a Record<string, any> of props that will be set on the component that is created.

Interface SurfaceComponentProps

NameTypeDescription
className?stringOptional class name to set on the surface component's container
data?anyOptional data to load after the component has been mounted.
injector?Optional function that is used to generate a set of props for a given vertex before rendering it. This provides a mechanism for you to inject specific items into the components you use to render your vertices. The return value of this function should be Record<string, any>. It may be null.
modelOptions?JsPlumbToolkitOptionsOptions for the underlying Toolkit instance.
renderOptions?SvelteSurfaceRenderOptionsRender options for the Surface.
shapeLibrary?ShapeLibraryImplShape library to use to render SVG shapes. Optional.
toolkit?JsPlumbToolkitOptional JsPlumb Toolkit to use. If this is not provided, a Toolkit instance will be created.
url?stringOptional url from which to load data after the component has been mounted. If you provide this and also data, this will take precedence.
viewOptions?SvelteSurfaceViewOptionsView options for the Surface.

Providers​

JsPlumb Svelte - from 6.80.0 onwards - has an implementation of React's concept of Providers, and this offers a means for you to build apps with JsPlumb with far less boilerplate than was previously required. In the component discussions on this page you can see how MiniviewComponent and ControlsComponent can be nested inside a SurfaceComponent, and also how PaletteComponent was nested inside a SurfaceProvider - these are examples of providers and context in action.

SurfaceProvider​

This provider offers a means for you to share a surface located somewhere in your UI with other components that are not necessarily descendants of the surface component. A common use case is for Inspectors and Palettes - often you'll find they do not exist as children of the surface element but rather elsewhere in the DOM, for instance:

<script>
import { SurfaceComponent,
ControlsComponent,
SurfaceProvider,
PaletteComponent,
MiniviewComponent } from '@jsplumbtoolkit/browser-ui-svelte'
</script>

<div class="row">
<SurfaceProvider>
<div class="col-9">
<SurfaceComponent/>
</div>
<div class="col-3 d-flex flex-column">
<PaletteComponent selector="li" dataGenerator={dataGenerator} typeExtractor={typeExtractor}>
<ul>
<li data-node-type="foo" jtk-is-group="true">FOO</li>
<li data-node-type="bar">BAR</li>
</ul>
</PaletteComponent>
<InspectorComponent/>
</div>
</SurfaceProvider>
</div>

Here we see a UI using Bootstrap, consisting of a surface across 9 columns, and then a right hand pane containing a palette and an inspector. The SurfaceProvider is a common parent for all of the JsPlumb components.


Shape libraries​

A shape library is a set of named shapes that you will use to render SVG inside the vertices in your application. These are discussed in detail in the shape libraries and shape-sets pages; here we provide an overview of the available Svelte integration with these modules.

Creating a shape library​

In Svelte, a shape library is created the same way as in Vanilla js. In the code below we create a shape library with flowchart and basic shapes, which we then inject into our SurfaceComponent:

<script>
import { SurfaceComponent } from "@jsplumbtoolkit/browser-ui-svelte"
import { FLOWCHART_SHAPES, BASIC_SHAPES, ShapeLibraryImpl, DEFAULT } from "@jsplumbtoolkit/browser-ui"

import NodeComponent from './NodeComponent.svelte'

const shapeLibrary = new ShapeLibraryImpl([FLOWCHART_SHAPES, BASIC_SHAPES])

const viewOptions = {
nodes: {
[DEFAULT]: {
component: NodeComponent
}
}
}
</script>

<div>
<SurfaceComponent viewOptions={viewOptions} shapeLibrary={shapeLibrary}/>
</div>

Rendering an SVG shape​

Shapes can be rendered with a ShapeComponent. This component needs to be given the data, vertex and surface props that are injected into the component used to render the vertex::

<script>
import { ShapeComponent } from "@jsplumbtoolkit/browser-ui-svelte"

export let surface
export let data
export let vertex

</script>

<div class="my-class">
<ShapeComponent data={data} vertex={vertex} surface={surface} />
</div>

Props​

NameTypeDescription
dataObjectDataBacking data for the vertex. Required. This is passed in as a prop to a component used to render a node/group, so you can pass it straight through from the parent to this component.
labelProperty?stringThe name of the property containing each vertex's label. Defaults to label.
labelStrokeWidthnumberStroke width to use on the text element rendering a label. Defaults to 1px.
showLabels?booleanWhether or not to show labels on each shape. Defaults to false.
surfaceSurfaceThe surface that is rendering the vertex. Required. Again, this is passed in to the parent component.
vertexVertex to render. Required. This is passed in as a prop to a component used to render a node/group, so you can pass it straight through from the parent to this component.

By default the shape component will render just the shape. If you want to add labels you can do so like this:

<script>
import { ShapeComponent } from "@jsplumbtoolkit/browser-ui-svelte"

export let surface
export let data
export let vertex

</script>

<div class="my-class">
<ShapeComponent showLabels={true} data={data} vertex={vertex} surface={surface} />
</div>

By default, JsPlumb will extract the label from a label property in your vertex data. You can provide the name of the property to use if you want to, by setting the labelProperty on your ShapeComponent:

<script>
import { ShapeComponent } from "@jsplumbtoolkit/browser-ui-svelte"

export let surface
export let data
export let vertex

</script>

<div class="my-class">
<ShapeComponent showLabels={true}
data={data}
vertex={vertex}
surface={surface}
labelProperty="text"
/>
</div>

Adding your own shapes​

To add your own shapes, you'll need to create a shape set. These are discussed on a separate page.


Dragging new nodes/groups​

Palettes offer a means for your users to drag new nodes/groups onto your canvas. The PaletteComponent is the main component you'll use; there's also a ShapeLibraryPaletteComponent which is a specialised version of the PaletteComponent that sources its draggable nodes from a ShapeLibrary.

HTML elements​

To configure your UI to drag and drop HTML elements onto your canvas, you'll use a PaletteComponent. Here's how to set one up:

<script>
import { PaletteComponent, SurfaceComponent, SurfaceProvider } from '@jsplumbtoolkit/browser-ui-svelte';

const dataGenerator = (el) => {
return {
w:120,
h:80,
type:el.getAttribute("data-node-type")
}
};
</script>

<div class="row">
<SurfaceProvider>
<div class="col-9">
<SurfaceComponent/>
</div>
<div class="col-3">
<PaletteComponent selector="li" dataGenerator={dataGenerator}>
<ul>
<li data-node-type="foo" jtk-is-group="true">FOO</li>
<li data-node-type="bar">BAR</li>
</ul>
</PaletteComponent>
</div>
</SurfaceProvider>
</div>

The basic contract is that you declare a PaletteComponent in your template, and you provide - at the minimum - a selector, which tells the palette component how to find which children of the component are draggable. You then write out the children however you like - in this case we use a ul and an li for each draggable type.

The PaletteComponent needs to know which surface it is going to be attached to, and it does this by being context aware - in the code above we have a SurfaceProvider wrapping both the surface component and the palette component. When the surface component is instantiated, it populates the surface provider's context, and the palette component is notified of the surface to use.

In the code above we also see a dataGenerator prop: dataGenerator provides a means for the component to generate an initial data payload for some node that is being dragged. The list of available props is:

Interface PaletteComponentProps

NameTypeDescription
className?stringOptional class name to set on the component's root element.
dataGenerator?DataGeneratorFunctionFunction to invoke to get a payload for an element that is being dragged. Defaults to a function that extracts type from the element via its data-type attribute.
selector?stringCSS selector identifying draggable elements. Defaults to '[data-type]'

SVG shapes​

To drag and drop SVG shapes, you can use a ShapeLibraryPaletteComponent. This is a specialised version of the PaletteComponent which sources its draggable nodes from a ShapeLibrary.

<script>
import { FLOWCHART_SHAPES, BASIC_SHAPES, ShapeLibraryImpl } from "@jsplumbtoolkit/browser-ui"
import { ShapeLibraryPaletteComponent, SurfaceComponent, SurfaceProvider } from "@jsplumbtoolkit/browser-ui-svelte"

const shapeLibrary = new ShapeLibraryImpl([FLOWCHART_SHAPES, BASIC_SHAPES])
const dataGenerator = (el)=> {
return {
w:120,
h:80,
type:el.getAttribute("data-node-type")
}
};
</script>

<div>
<SurfaceProvider>
<SurfaceComponent viewOptions={viewOptions} shapeLibrary={shapeLibrary}/>
<ShapeLibraryPaletteComponent className="node-palette"
dataGenerator={dataGenerator} initialSet={FLOWCHART_SHAPES.id}/>
</SurfaceProvider>
</div>

As with PaletteComponent, the ShapeLibraryPaletteComponent is context aware and can locate the surface to use from a SurfaceProvider.

The full list of available props is:

NameTypeDescription
allowClickToAdd?booleanWhen in tap mode, allow addition of new vertices simply by clicking, instead of requiring a shape be drawn. (When this is true, the drawing method also still works)
autoExitDrawMode?booleanDefaults to true: when in 'tap' mode and a new group/node has been drawn on the canvas, the surface is set back to pan mode.
canvasStrokeWidth?numberStroke width to use for shapes dropped on canvas. Defaults to 2.
dataGenerator?DataGeneratorFunctionOptional data generator to allow you to specify initial data for some element to be dragged. Note that you cannot override the object's type with this function. The palette will set the new object's type to match the type of the element that the user is dragging from the palette.
dragSize?SizeOptional size to use for dragged elements.
fill?stringOptional fill color to use for dragged elements. This should be in RGB format, _not_ a color like 'white' or 'cyan' etc.
iconSize?SizeOptional size to use for icons. Defaults to 150x100 pixels. If you provide this but not dragSize this size will also be used for an icon that is being dragged.
initialSet?stringOptional ID of the first set to show, hiding the others.
mode?DropManagerModeMode to operate in - 'drag' or 'tap'. Defaults to 'drag' (DROP_MANAGER_MODE_DRAG).
onVertexAdded?Optional callback to invoke when a new vertex has been added
outline?stringOptional color to use for outline of dragged elements. Should be in RGB format.
paletteStrokeWidth?numberStroke width to use for shapes in palette. Defaults to 1.
selectAfterDrop?booleanWhen true (which is the default), a newly dropped vertex will be set as the underlying Toolkit's selection.
showAllMessage?stringMessage to use for the 'show all' option in the shape set drop down when there is more than one set of shapes. Defaults to Show all.
showLabels?booleanOptionally show each icon's label underneath it

Component List​

This is a full list of the components that are available in JsPlumb Svelte. For each we provide a sample usage, which does not necessarily use all of the props available for the given component. We then provide the full list of available props.

SurfaceComponent​

The key UI component you'll use to render your UI.

<SurfaceComponent renderOptions={someRenderOptions} 
viewOptions={someViewOptions}/>

Interface SurfaceComponentProps

NameTypeDescription
className?stringOptional class name to set on the surface component's container
data?anyOptional data to load after the component has been mounted.
injector?Optional function that is used to generate a set of props for a given vertex before rendering it. This provides a mechanism for you to inject specific items into the components you use to render your vertices. The return value of this function should be Record<string, any>. It may be null.
modelOptions?JsPlumbToolkitOptionsOptions for the underlying Toolkit instance.
renderOptions?SvelteSurfaceRenderOptionsRender options for the Surface.
shapeLibrary?ShapeLibraryImplShape library to use to render SVG shapes. Optional.
toolkit?JsPlumbToolkitOptional JsPlumb Toolkit to use. If this is not provided, a Toolkit instance will be created.
url?stringOptional url from which to load data after the component has been mounted. If you provide this and also data, this will take precedence.
viewOptions?SvelteSurfaceViewOptionsView options for the Surface.

MiniviewComponent​

Provides a Miniview of the contents of some surface. This component can be nested inside a SurfaceComponent, from which it will find the surface to attach to, or it can also exist as a descendant of a SurfaceProvider - the approach you choose will depend on the structure of your page.

Example​

<SurfaceComponent renderOptions={renderOptions}>
<MiniviewComponent/>
</SurfaceComponent>

Interface MiniviewComponentProps

NameTypeDescription
activeTracking?booleanDefaults to true, meaning the miniview actively updates as nodes/groups are dragged on the related surface. If this is set to false, the miniview only updates after mouseup.
clickToCenter?booleanDefaults to true, meaning a click on a node/group in the miniview will cause that node/group to be centered in the related surface.
collapsible?booleanDefaults to true, determines whether or not the miniview can be collapsed.
elementFilter?Optional filter for elements to display. Defaults to undefined - all elements displayed.
enableWheelZoom?booleanDefaults to true, Whether or not to enable the wheel zoom.
typeFunction?Optional function to use to derive a type for each rendered node/group. This is written onto the corresponding element as the value of the data-jtk-miniview-type attribute, and can be useful for styling.
visible?booleanDefaults to true. Whether or not the miniview is initially visible.
wheelReverse?booleanDefaults to false. Whether or not to reverse the zoom direction in response to a wheel event.
wheelSensitivity?numberOptional overide for how sensitive the wheel zoom should be.

ControlsComponent​

Provides a component that offers a set of controls for some surface. If there is a lasso plugin installed on the given surface this component will show buttons for pan/select mode, otherwise it will not. This component can be nested inside a SurfaceComponent, from which it will find the surface to attach to, or it can also exist as a descendant of a SurfaceProvider - the approach you choose will depend on the structure of your page.

Controls component - jsPlumb Toolkit - JavaScript diagramming library that fuels exceptional UIs

Example​

<script>
import { SurfaceComponent, ControlsComponent } from "@jsplumbtoolkit/browser-ui-svelte"

const renderOptions = { ... }
</script>

<SurfaceComponent renderOptions={renderOptions}>
<ControlsComponent/>
</SurfaceComponent>

Props​

Interface ControlsComponentProps

NameTypeDescription
buttons?ControlsComponentButtonsOptional extra buttons to add to the controls component.
clear?booleanWhether or not to show the clear button, defaults to true.
clearMessage?stringOptional message to show the user when prompting them to confirm they want to clear the dataset
orientation?Optional orientation for the controls. Defaults to 'row'.
undoRedo?booleanWhether or not to show undo/redo buttons, defaults to true
zoomToExtents?booleanWhether or not to show the zoom to extents button, defaults to true

ExportControlsComponent​

Provides a component that offers a set of buttons users can click to generate SVG, PNG or JPG output of the canvas.

Controls component - jsPlumb Toolkit, flowcharts, chatbots, bar charts, decision trees, mindmaps, org charts and more

Example​

<script>
import { SurfaceComponent, ExportControlsComponent } from "@jsplumbtoolkit/browser-ui-svelte"

const renderOptions = { ... }

</script>

<SurfaceComponent renderOptions={renderOptions}>
<ExportControlsComponent/>
</SurfaceComponent>

Props​

Interface ExportControlsComponentProps

NameTypeDescription
allowJpgExport?booleanDefaults to true.
allowPngExport?booleanDefaults to true.
allowSvgExport?booleanDefaults to true.
imageOptions?ImageExportUIOptionsOptions for image exports.
label?stringWhat to show in the label, if visible. Defaults to "Export:".
showLabel?booleanWhether or not to show a label in front of the buttons. Defaults to true.
svgOptions?SvgExportUIOptionsOptions for SVG exports.

PaletteComponent​

Provides a means to implement drag/drop of new Nodes/Groups onto your Surface. This component can be nested inside a SurfaceComponent, from which it will find the surface to attach to, or it can also exist as a descendant of a SurfaceProvider - the approach you choose will depend on the structure of your page.

Example​


import { PaletteComponent, SurfaceComponent, SurfaceProvder } from '@jsplumbtoolkit/browser-ui-svelte';

export default function MyApp() {

const typeExtractor = function(el) { return el.getAttribute("data-node-type") };
const dataGenerator = function (type) { return { w:120, h:80 }; };

return <div className="row">
<SurfaceProvider>
<div className="col-9">
<SurfaceComponent/>
</div>
<div className="col-3">
<PaletteComponent selector="li" dataGenerator={dataGenerator} typeExtractor={typeExtractor}>
<ul>
<li data-node-type="foo" jtk-is-group="true">FOO</li>
<li data-node-type="bar">BAR</li>
</ul>
</PaletteComponent>
</div>
</SurfaceProvider>
</div>
}

Props​

Interface PaletteComponentProps

NameTypeDescription
className?stringOptional class name to set on the component's root element.
dataGenerator?DataGeneratorFunctionFunction to invoke to get a payload for an element that is being dragged. Defaults to a function that extracts type from the element via its data-type attribute.
selector?stringCSS selector identifying draggable elements. Defaults to '[data-type]'

ShapeLibraryPaletteComponent​

This is a specialised version of the PaletteComponent which sources its draggable nodes from a ShapeLibrary.

Example​

<script>

import { FLOWCHART_SHAPES, BASIC_SHAPES, ShapeLibraryImpl } from "@jsplumbtoolkit/browser-ui"
import { ShapeLibraryPaletteComponent, SurfaceComponent, SurfaceProvider } from "@jsplumbtoolkit/browser-ui-svelte"

const shapeLibrary = new ShapeLibraryImpl([FLOWCHART_SHAPES, BASIC_SHAPES])
const dataGenerator = (el) => {
return {
w:120,
h:80,
type:el.getAttribute("data-node-type")
}
};

</script>

<div>
<SurfaceProvider>
<SurfaceComponent viewOptions={viewOptions}/>
<ShapeLibraryPaletteComponent className="node-palette"
shapeLibrary={shapeLibrary}
dataGenerator={dataGenerator}
initialSet={FLOWCHART_SHAPES.id}/>
</SurfaceProvider>
</div>

Props​

Interface ShapeLibraryPaletteComponentProps

NameTypeDescription
allowClickToAdd?booleanWhen in tap mode, allow addition of new vertices simply by clicking, instead of requiring a shape be drawn. (When this is true, the drawing method also still works)
autoExitDrawMode?booleanDefaults to true: when in 'tap' mode and a new group/node has been drawn on the canvas, the surface is set back to pan mode.
canvasStrokeWidth?numberStroke width to use for shapes dropped on canvas. Defaults to 2.
dataGenerator?DataGeneratorFunctionOptional data generator to allow you to specify initial data for some element to be dragged. Note that you cannot override the object's type with this function. The palette will set the new object's type to match the type of the element that the user is dragging from the palette.
dragSize?SizeOptional size to use for dragged elements.
fill?stringOptional fill color to use for dragged elements. This should be in RGB format, _not_ a color like 'white' or 'cyan' etc.
iconSize?SizeOptional size to use for icons. Defaults to 150x100 pixels. If you provide this but not dragSize this size will also be used for an icon that is being dragged.
initialSet?stringOptional ID of the first set to show, hiding the others.
mode?DropManagerModeMode to operate in - 'drag' or 'tap'. Defaults to 'drag' (DROP_MANAGER_MODE_DRAG).
onVertexAdded?Optional callback to invoke when a new vertex has been added
outline?stringOptional color to use for outline of dragged elements. Should be in RGB format.
paletteStrokeWidth?numberStroke width to use for shapes in palette. Defaults to 1.
selectAfterDrop?booleanWhen true (which is the default), a newly dropped vertex will be set as the underlying Toolkit's selection.
showAllMessage?stringMessage to use for the 'show all' option in the shape set drop down when there is more than one set of shapes. Defaults to Show all.
showLabels?booleanOptionally show each icon's label underneath it

ShapeComponent​

This component is used in conjunction with a ShapeLibrary to render SVG shapes.

Example​

<script>
import { ShapeComponent } from "@jsplumbtoolkit/browser-ui-svelte"

export let data
export let vertex
export let surface

</script>


<div class="my-class">
<ShapeComponent data={data}
vertex={vertex}
surface={surface}
showLabels={true}
labelProperty="text"/>
</div>

Props​

Interface ShapeComponentProps

NameTypeDescription
dataObjectDataBacking data for the vertex. Required. This is passed in as a prop to a component used to render a node/group, so you can pass it straight through from the parent to this component.
labelProperty?stringThe name of the property containing each vertex's label. Defaults to label.
labelStrokeWidthnumberStroke width to use on the text element rendering a label. Defaults to 1px.
showLabels?booleanWhether or not to show labels on each shape. Defaults to false.
surfaceSurfaceThe surface that is rendering the vertex. Required. Again, this is passed in to the parent component.
vertexVertex to render. Required. This is passed in as a prop to a component used to render a node/group, so you can pass it straight through from the parent to this component.

Skip to main content

JsPlumb React

JsPlumb has several components to assist you to integrate with React. We recommend React 17 or later, but some users have reported that they have apps running with JsPlumb in React 16. JsPlumb has been tested against React 17, React 18 and NextJS 14.0.3.

Imports

"dependencies":{
"@jsplumbtoolkit/browser-ui-react":"6.81.0"
}

Quick start

The main component you will use is the SurfaceComponent. Let's take a quick look at how you'd use one:


import React from "react"

import {
MiniviewComponent,
SurfaceComponent,
ControlsComponent
}
from '@jsplumbtoolkit/browser-ui-react';

export default function DemoComponent({someProps}) {

const data = {
nodes:[
{ id:"1", label:"1", left:50, top:50},
{ id:"2", label:"TWO", left:250, top:250}
],
edges:[
{ source:"1", target:"2" }
]
}

return <div style={{width:"100%",height:"100%"}}>
<SurfaceComponent data={data}>
<ControlsComponent/>
<MiniviewComponent/>
</SurfaceComponent>
</div>

}

In the above example the only prop we set on the SurfaceComponent was data, meaning the component uses a default Absolute layout and some default JSX for rendering nodes. The SurfaceComponent, though, is highly configurable, mainly through its viewOptions and renderOptions props. Here's the same example from before but with a few more things configured:


import React from "react"

import {
MiniviewComponent,
SurfaceComponent,
ControlsComponent
}
from '@jsplumbtoolkit/browser-ui-react';

export default function DemoComponent({someProps}) {

const data = {
nodes:[
{ id:"1", label:"1", left:50, top:50},
{ id:"2", label:"TWO", left:250, top:250}
],
edges:[
{ source:"1", target:"2" }
]
}

const viewOptions = {
nodes:{
default:{
jsx:(ctx) => <div style={{width:"60px", height:"60px", backgroundColor:"white", border:"1px solid black", text-align:"center"}}><h3>{ctx.data.label}</h3></div>
}
}
}

const renderOptions = {
layout:{
type:"ForceDirected"
},
grid:{
size:{
w:50, h:50
}
}
}

return <div style={{width:"100%",height:"100%"}}>
<SurfaceComponent data={data} renderOptions={renderOptions} viewOptions={viewOptions}>
<ControlsComponent/>
<MiniviewComponent/>
</SurfaceComponent>
</div>

}


Rendering Nodes and Groups

At the core of your UI will be a SurfaceComponent, which provides the canvas onto which nodes, groups and edges are drawn. In the Quickstart section above we show a couple of examples of the SurfaceComponent in action.

Each node or group in your UI is rendered as an individual component. In the first example above, we rely on JsPlumb's default JSX to render each node, but in the second we provide some JSX ourselves, although its quite simple. In a real world app your JSX will likely be more complex. As an example, consider the component we use to render nodes in the Flowchart Builder:

import * as React from 'react';

import { ShapeComponent } from "@jsplumbtoolkit/browser-ui-react"

import anchorPositions from "./anchor-positions"

export default function NodeComponent({ctx, shapeLibrary}) {

const { vertex, toolkit } = ctx;
const data = vertex.data;

return <div style={{color:data.textColor}} className="flowchart-object" data-jtk-target="true">

<ShapeComponent obj={data} shapeLibrary={shapeLibrary} showLabels={true} labelProperty="text"/>

{anchorPositions.map(ap => <div className={"jtk-connect jtk-connect-" + ap.id} data-jtk-anchor-x={ap.x} data-jtk-anchor-y={ap.y} data-jtk-orientation-x={ap.ox} data-jtk-orientation-y={ap.oy} data-jtk-source="true" data-jtk-port-type="source" key={ap.id}></div>)}

<div className="node-delete node-action delete" onClick={() => toolkit.removeNode(vertex)}></div>
</div>
}

The contents of the JSX used to render each node/group are entirely up to you.

Mapping types to JSX

The viewOptions prop is used to map node/group types to JSX, and to certain behaviours. For instance, this is the nodes section of the viewOptions for the flowchart builder starter app:

import { DEFAULT, newInstance } from "@jsplumbtoolkit/browser-ui"
import NodeComponent from "./NodeComponent.jsx"

const shapeLibrary = ...
const toolkit = newInstance(....)

const view = {
nodes: {
[DEFAULT]: {
jsx: (ctx) => {
return <NodeComponent ctx={ctx} shapeLibrary={shapeLibrary}/>
},
// connections to/from this node can exist at any of the given anchorPositions
anchorPositions,
// node can support any number of connections.
maxConnections: -1,
events: {
[EVENT_TAP]: (params) => {
surface.current.stopEditingPath()
// if zero nodes currently selected, or the shift key wasnt pressed, make this node the only one in the selection.
if (toolkit.getSelection()._nodes.length < 1 || params.e.shiftKey !== true) {
toolkit.setSelection(params.obj)
} else {
// if multiple nodes already selected, or shift was pressed, add this node to the current selection.
toolkit.addToSelection(params.obj)
}
}
}
}
},
}

To map a node/group type to some JSX, you're expected to provide a function that takes ctx as argument, and returns JSX.

ctx is an object containing five things:

interface JsxContext {
vertex: Node | Group; // the vertex - node or group - that is being rendered by this JSX
surface: Surface; // the Surface widget that is rendering the vertex
toolkit: JsPlumbToolkit; // the underlying JsPlumbToolkit instance
data: Record<string, any>; // the vertex's backing data. This is just a convenience - it can be accessed via `vertex.data`
props: Record<string, any>; // these are any props that you passed in as the `childProps` argument to a `SurfaceComponent`. See below.
}

As mentioned above, you can pass back arbitrary JSX from these functions.

In this view you'll also see we pass a shapeLibrary in to each component - the demonstration uses a ShapeLibrary to draw the various flowchart shapes. What you pass in to your JSX is entirely your choice - JsPlumb gives you the ctx variable and you can use it how you like.

Passing props

You can pass props in to the components used to render your vertices by setting them on the childProps prop of a Surface component. For instance, in the , DemoComponent - the main app - declares a random color variable in its initial state:

class DemoComponent extends React.Component {

constructor(props) {
super(props);
this.toolkit = jsPlumbToolkit.newInstance();
this.state = { color:randomColor() };

}

}

In the render method of the DemoComponent, a surface component is created, and the color member of the main component's state is passed in:

render() {
return <div style={{width:"100%",height:"100%",display:"flex"}}>
<button onClick={this.changeColor.bind(this)} style={{backgroundColor:this.state.color}} className="colorButton">Change color</button>
<SurfaceComponent childProps={{color:this.state.color}} renderOptions={this.renderOptions} toolkit={this.toolkit} view={this.view} />
</div>
}

In the view for the DemoComponent, each of the node types references the Surface's childProps by way of the context they are given:

this.view = {
nodes: {
"shin":{
jsx: (ctx) => { return <ShinBoneComponent color={ctx.props.color} ctx={ctx}/> }
},
"knee":{
jsx: (ctx) => { return <KneeBoneComponent color={ctx.props.color} ctx={ctx}/> }
}
},
...
}

So, here, ctx.props.color is referencing this.state.color in DemoComponent. If we change DemoComponent's state, the change propagates through to the vertex components:

changeColor() {
const current = this.state.color;
let col;
while (true) {
col = randomColor();
if (col !== current) {
break;
}
}
this.setState({ color:col } )
}

Context and Providers

JsPlumb React - from 6.40.0 onwards - has support for React's concepts of Context and Providers, and this offers a means for you to build apps with JsPlumb with far less boilerplate than was previously required. In the component discussions above you can see how MiniviewComponent and ControlsComponent can be nested inside a SurfaceComponent, and also how PaletteComponent was nested inside a SurfaceProvider - these are examples of providers and context in action.

For a primer on providers and context you can check out the React docs.

A Context is a means for some component to provide data to all of its descendants. JsPlumb React has two.

JsPlumbContext

This context contains an instance of the JsPlumb Toolkit - the underlying data model. A JsPlumbContext is created when a JsPlumbProvider is declared in your JSX. It's not as common to need a JsPlumbContext as it is to need a SurfaceContext: it's typically only needed in apps that wish to render one data model to more than one canvas.

SurfaceContext

This context contains a Surface. A SurfaceContext is created when:

  • a SurfaceProvider is declared in your JSX (see below); or
  • a SurfaceComponent is created and it is not inside an existing SurfaceContext

In the component examples above, we see the MiniviewComponent and ControlsComponent declared without any props, as children of a SurfaceComponent. The SurfaceComponent populates a SurfaceContext with the surface it has created, and the MiniviewComponent and ControlsComponent discover the surface via the SurfaceContext:

<SurfaceComponent renderOptions={renderOptions}>
<ControlsComponent/>
<MiniviewComponent/>
</SurfaceComponent>

SurfaceProvider

This provider offers a means for you to share a surface located somewhere in your UI with other components that are not necessarily descendants of the surface component. A common use case is for Inspectors and Palettes - often you'll find they do not exist as children of the surface element but rather elsewhere in the DOM, for instance:

<div className="row">
<SurfaceProvider>
<div className="col-9">
<SurfaceComponent/>
</div>
<div className="col-3 d-flex flex-column">
<PaletteComponent selector="li" dataGenerator={dataGenerator} typeExtractor={typeExtractor}>
<ul>
<li data-node-type="foo" jtk-is-group="true">FOO</li>
<li data-node-type="bar">BAR</li>
</ul>
</PaletteComponent>
<InspectorComponent/>
</div>
</SurfaceProvider>
</div>

Here we see a UI using Bootstrap, consisting of a surface across 9 columns, and then a right hand pane containing a palette and an inspector. The SurfaceProvider is a common parent for all of the JsPlumb components.

JsPlumbProvider

This provides a JsPlumbContext - a typical use case is when you want to render some data model to more than one place.

<div className="row">
<JsPlumbProvider>
<div className="col-6">
<SurfaceComponent/>
</div>
<div className="col-6">
<SurfaceComponent/>
</div>
</JsPlumbProvider>
</div>

Shape libraries

A shape library is a set of named shapes that you will use to render SVG inside the vertices in your application. These are discussed in detail in the shape libraries and shape-sets pages; here we provide an overview of the available React integration with these modules.

Creating a shape library

In React, a shape library is created the same way as in vanilla js. In the code below we create a shape library with flowchart and basic shapes, which we then inject into our SurfaceComponent:

import React from 'react';
import { FLOWCHART_SHAPES, BASIC_SHAPES, ShapeLibraryImpl, DEFAULT } from "@jsplumbtoolkit/browser-ui"

import NodeComponent from './node-component'

export default function FlowchartComponent() {

const shapeLibrary = new ShapeLibraryImpl([FLOWCHART_SHAPES, BASIC_SHAPES])

const viewOptions = {
nodes: {
[DEFAULT]: {
jsx: (ctx) => {
return <NodeComponent ctx={ctx} />
}
}
}
}

return <div>
<SurfaceComponent viewOptions={viewOptions} shapeLibrary={shapeLibrary}/>
</div>

Rendering an SVG shape

Shapes can be rendered with a ShapeComponent. This takes the ctx that JsPlumb passes into your JSX inside the view as a prop, from which it can extract the current vertex and the underlying surface, plus the shape library the surface is using:

import * as React from 'react';

import { ShapeComponent } from "@jsplumbtoolkit/browser-ui-react"

export default function NodeComponent({ctx}) {

return <div className="my-class">
<ShapeComponent ctx={ctx} />
</div>
}

Props

NameTypeDescription
ctxJsxWrapperPropsContext for the vertex, as passed in by the SurfaceComponent.
labelProperty?stringThe name of the property that identifies some vertex's label. Defaults to "label".
labelStrokeWidth?stringOptional stroke width to use for labels. Defaults to "0.25px".
showLabels?booleanDefaults to false. If true, a label will be written on the shape (using an SVG text element).

By default the shape component will render just the shape. If you want to add labels you can do so like this:

import * as React from 'react';

import { ShapeComponent } from "@jsplumbtoolkit/browser-ui-react"

export default function NodeComponent({ctx}) {

return <div className="my-class">
<ShapeComponent ctx={ctx} showLabels={true}/>
</div>
}

By default, JsPlumb will extract the label from a label property in your vertex data. You can provide the name of the property to use if you want to, by setting the labelProperty on your ShapeComponent:

import * as React from 'react';

import { ShapeComponent } from "@jsplumbtoolkit/browser-ui-react"

export default function NodeComponent({ctx}) {

return <div className="my-class">
<ShapeComponent ctx={ctx} showLabels={true} labelProperty="text"/>
</div>
}

Adding your own shapes

To add your own shapes, you'll need to create a shape set. These are discussed on a separate page.


Dragging new nodes/groups

Palettes offer a means for your users to drag new nodes/groups onto your canvas. The PaletteComponent is the main component you'll use; there's also a ShapeLibraryPaletteComponent which is a specialised version of the PaletteComponent that sources its draggable nodes from a ShapeLibrary.

HTML elements

To configure your UI to drag and drop HTML elements onto your canvas, you'll use a PaletteComponent. Here's how to set one up:


import { PaletteComponent, SurfaceComponent, SurfaceProvider } from '@jsplumbtoolkit/browser-ui-react';

export default function MyApp() {

const dataGenerator = (el) => {
return {
w:120,
h:80,
type:el.getAttribute("data-node-type")
}
};

return <div className="row">
<SurfaceProvider>
<div className="col-9">
<SurfaceComponent/>
</div>
<div className="col-3">
<PaletteComponent selector="li" dataGenerator={dataGenerator}>
<ul>
<li data-node-type="foo" jtk-is-group="true">FOO</li>
<li data-node-type="bar">BAR</li>
</ul>
</PaletteComponent>
</div>
</SurfaceProvider>
</div>
}

The basic contract is that you declare a PaletteComponent in your JSX, and you provide - at the minimum - a selector, which tells the palette component how to find which children of the component are draggable. You then write out the children however you like - in this case we use a ul and an li for each draggable type.

The PaletteComponent needs to know which surface it is going to be attached to, and it does this by being context aware - in the code above we have a SurfaceProvider wrapping both the surface component and the palette component. When the surface component is instantiated, it populates the surface provider's context, and the palette component is notified of the surface to use.

In the code above we also see a dataGenerator prop: dataGenerator provides a means for the component to generate an initial data payload for some node that is being dragged. The list of available props is:

Interface PaletteComponentProps

NameTypeDescription
allowDropOnCanvas?stringWhether or not to allow drop on whitespace in the canvas. Defaults to true.
allowDropOnEdge?stringWhether or not to allow drop on edge. Defaults to false.
allowDropOnGroup?stringWhether or not to allow drop on existing vertices. Defaults to true.
children?Child elements. Although this is optional it is expected there will be some - otherwise the palette does nothing.
className?stringOptional extra css classes to set on the element
dataGenerator?DataGeneratorFunctionFunction to use to get a dataset for an item that is being dragged.
groupIdentifier?GroupIdentifierFunctionFunction to use to determine whether an item that is being dragged represents a group.
selectorstringCSS 3 selector identifying what child elements of container are draggable.
surface?SurfaceThe surface to attach to. Optional: this component can derive a surface from a SurfaceProvider or SurfaceComponent.
typeGenerator?TypeGeneratorFunctionFunction to use to get the type of an item that is being dragged.

SVG shapes

To drag and drop SVG shapes, you can use a ShapeLibraryPaletteComponent. This is a specialised version of the PaletteComponent which sources its draggable nodes from a ShapeLibrary.

import React, { useEffect, useRef} from 'react';
import { FLOWCHART_SHAPES, BASIC_SHAPES, ShapeLibraryImpl } from "@jsplumbtoolkit/browser-ui"
import { ShapeLibraryPaletteComponent, SurfaceComponent, SurfaceProvider } from "@jsplumbtoolkit/browser-ui-react"

export default function FlowchartComponent() {

const shapeLibrary = new ShapeLibraryImpl([FLOWCHART_SHAPES, BASIC_SHAPES])
const dataGenerator = (el) => {
return {
w:120,
h:80,
type:el.getAttribute("data-node-type")
}
};

return <div>
<SurfaceProvider>
<SurfaceComponent viewOptions={viewOptions} shapeLibrary={shapeLibrary}/>
<ShapeLibraryPaletteComponent className="node-palette"
dataGenerator={dataGenerator} initialSet={FLOWCHART_SHAPES.id}/>
</SurfaceProvider>

</div>

As with PaletteComponent, the ShapeLibraryPaletteComponent is context aware and can locate the surface to use from a SurfaceProvider.

The full list of available props is:

NameTypeDescription
canvasStrokeWidth?numberStroke width to use for shapes dropped on canvas. Defaults to 2.
dataGenerator?DataGeneratorFunctionOptional data generator to allow you to specify initial data for some element to be dragged. Note that you cannot override the object's type with this function. The palette will set the new object's type to match the type of the element that the user is dragging from the palette.
dragSize?SizeOptional size to use for dragged elements.
fill?stringOptional fill color to use for dragged elements. This should be in RGB format, _not_ a color like 'white' or 'cyan' etc.
iconSize?SizeOptional size to use for icons.
initialSet?stringID of the initial set to show, if any. When you have multiple shapes in a set you may want the palette to open up showing just one set.
outline?stringOptional color to use for outline of dragged elements. Should be in RGB format.
paletteStrokeWidth?numberStroke width to use for shapes in palette. Defaults to 1.
selectAfterDrop?booleanWhen true (which is the default), a newly dropped vertex will be set as the underlying Toolkit's selection.
shapeLibrary?ShapeLibraryImplThe shape library to render.
showAllMessage?stringMessage to use for the 'show all' option in the shape set drop down when there is more than one set of shapes. Defaults to Show all.
surface?SurfaceSurface to attach the drag/drop to. Optional; this component can extract the Surface from a SurfaceProvider, or from being a child of a SurfaceComponent.

Component List

This is a full list of the components that are available in JsPlumb React. For each we provide a sample usage, which does not necessarily use all of the props available for the given component. We then provide the full list of available props.

SurfaceComponent

The key UI component you'll use to render your UI.

<SurfaceComponent renderOptions={someRenderOptions} 
viewOptions={someViewOptions}/>

Interface SurfaceComponentProps

NameTypeDescription
childProps?anyAny props to pass to children.
className?stringOptional class name to append to the root element's class list.
data?anyOptional initial data
modelOptions?JsPlumbToolkitOptionsOptions for the underlying JsPlumb Toolkit instance. If you use this component as a child of a JsPlumbComponent then the underlying JsPlumb instance will be sourced from the JsPlumbComponent. Otherwise, this component will instantiate a JsPlumb instance itself, optionally using these params.
renderOptions?ReactSurfaceRenderOptionsRender options such as layout, drag options etc
shapeLibrary?ShapeLibraryImplOptional shape library for the underlying surface to use. You can provide this or you can also provide a shapes render option to the surface.
surfaceId?stringOptional ID to assign to the surface that is created.
toolkit?BrowserUIReactJsPlumb instance to use - optional. The SurfaceComponent will create find a JsPlumb instance in an enclosing JsPlumbContext, if applicable, or otherwise will create its own JsPlumb instance (for which you can provide modelOptions if you wish)
url?stringOptional URL to load initial data from.
viewOptions?ReactSurfaceViewOptionsMappings of vertex types to components/jsx and edge types.

MiniviewComponent

Provides a Miniview of the contents of some surface. This component can be nested inside a SurfaceComponent, from which it will find the surface to attach to, or it can also exist as a descendant of a SurfaceProvider - the approach you choose will depend on the structure of your page.

Example


export default function MyComponent() {
return <SurfaceComponent renderOptions={renderOptions}>
<MiniviewComponent/>
</SurfaceComponent>
}

Interface MiniviewComponentProps

NameTypeDescription
activeTracking?booleanWhether or not to move miniview elements at the same time as their related surface element is being dragged. Defaults to true.
className?stringOptional class name to append to the root element's class list.
clickToCenter?booleanDefaults to true, meaning a click on a node/group in the miniview will cause that node/group to be centered in the related surface.
elementFilter?Optional filter to decide which elements to show in the miniview.
typeFunction?Optional function to use to decorate miniview elements with a jtk-miniview-type attribute. Can be used for simple styling.

ControlsComponent

Provides a component that offers a set of controls for some surface. If there is a lasso plugin installed on the given surface this component will show buttons for pan/select mode, otherwise it will not. This component can be nested inside a SurfaceComponent, from which it will find the surface to attach to, or it can also exist as a descendant of a SurfaceProvider - the approach you choose will depend on the structure of your page.

Controls component - jsPlumb Toolkit, industry standard diagramming and rich visual UI Javascript library

Example


import { SurfaceComponent, ControlsComponent } from "@jsplumbtoolkit/browser-ui-react"

export default function MyComponent() {

const renderOptions = { ... }

return <SurfaceComponent renderOptions={renderOptions}>
<ControlsComponent/>
</SurfaceComponent>
}

Props

Interface ControlsComponentProps

NameTypeDescription
buttons?ControlsComponentButtonsOptional extra buttons to add to the controls component.
className?stringOptional class name to append to the root element's class list.
clear?booleanWhether or not to show the clear button, defaults to true.
clearMessage?stringOptional message for the alert that the clear button shows by default. Defaults to Clear dataset?.
onMaybeClear?Optional callback to invoke when the user presses the clear button. If you provide this, the component will not show an alert and instead call this method, passing in a function you can invoke if you wish to continue with the clear operation.
orientation?Optional orientation for the controls. Defaults to 'row'.
surfaceId?stringThe ID of surface to attach to. Optional.
undoRedo?booleanWhether or not to show undo/redo buttons, defaults to true
zoomToExtents?booleanWhether or not to show the zoom to extents button, defaults to true

ExportControlsComponent

Provides a component that offers a set of buttons users can click to generate SVG, PNG or JPG output of the canvas.

Controls component - jsPlumb Toolkit, industry standard diagramming and rich visual UI Javascript library

Example


export default function MyComponent() {
return <SurfaceComponent renderOptions={renderOptions}>
<ExportControlsComponent/>
</SurfaceComponent>
}

Props

Interface ExportControlsComponentProps

NameTypeDescription
allowJpgExport?booleanDefaults to true.
allowPngExport?booleanDefaults to true.
allowSvgExport?booleanDefaults to true.
imageOptions?ImageExportUIOptionsOptions for image exports.
label?stringWhat to show in the label, if visible. Defaults to "Export:".
margins?PointXYOptional margins to apply to both SVG and image exports. Will not override any margins specified in svgOptions or imageOptions.
showLabel?booleanWhether or not to show a label in front of the buttons. Defaults to true.
surfaceId?stringThe ID of surface to attach to. Optional.
svgOptions?SvgExportUIOptionsOptions for SVG exports.

PaletteComponent

Provides a means to implement drag/drop of new Nodes/Groups onto your Surface. This component can be nested inside a SurfaceComponent, from which it will find the surface to attach to, or it can also exist as a descendant of a SurfaceProvider - the approach you choose will depend on the structure of your page.

Example


import { PaletteComponent, SurfaceComponent, SurfaceProvder } from '@jsplumbtoolkit/browser-ui-react';

export default function MyApp() {

const typeExtractor = function(el) { return el.getAttribute("data-node-type") };
const dataGenerator = (el) => { return { w:120, h:80 }; };

return <div className="row">
<SurfaceProvider>
<div className="col-9">
<SurfaceComponent/>
</div>
<div className="col-3">
<PaletteComponent selector="li" dataGenerator={dataGenerator} typeExtractor={typeExtractor}>
<ul>
<li data-node-type="foo" jtk-is-group="true">FOO</li>
<li data-node-type="bar">BAR</li>
</ul>
</PaletteComponent>
</div>
</SurfaceProvider>
</div>
}

Props

Interface PaletteComponentProps

NameTypeDescription
allowDropOnCanvas?stringWhether or not to allow drop on whitespace in the canvas. Defaults to true.
allowDropOnEdge?stringWhether or not to allow drop on edge. Defaults to false.
allowDropOnGroup?stringWhether or not to allow drop on existing vertices. Defaults to true.
children?Child elements. Although this is optional it is expected there will be some - otherwise the palette does nothing.
className?stringOptional extra css classes to set on the element
dataGenerator?DataGeneratorFunctionFunction to use to get a dataset for an item that is being dragged.
groupIdentifier?GroupIdentifierFunctionFunction to use to determine whether an item that is being dragged represents a group.
selectorstringCSS 3 selector identifying what child elements of container are draggable.
surface?SurfaceThe surface to attach to. Optional: this component can derive a surface from a SurfaceProvider or SurfaceComponent.
typeGenerator?TypeGeneratorFunctionFunction to use to get the type of an item that is being dragged.

ShapeLibraryPaletteComponent

This is a specialised version of the PaletteComponent which sources its draggable nodes from a ShapeLibrary.

Example

import React, { useEffect, useRef} from 'react';
import { FLOWCHART_SHAPES, BASIC_SHAPES, ShapeLibraryImpl } from "@jsplumbtoolkit/browser-ui"
import { ShapeLibraryPaletteComponent, SurfaceComponent, SurfaceProvider } from "@jsplumbtoolkit/browser-ui-react"

export default function FlowchartComponent() {

const shapeLibrary = new ShapeLibraryImpl([FLOWCHART_SHAPES, BASIC_SHAPES])
const dataGenerator = (el) => { return { w:120, h:80, type:el.getAttribute("data-node-type") } };

return <div>
<SurfaceProvider>
<SurfaceComponent viewOptions={viewOptions}/>
<ShapeLibraryPaletteComponent className="node-palette"
shapeLibrary={shapeLibrary} dataGenerator={dataGenerator} initialSet={FLOWCHART_SHAPES.id}/>
</SurfaceProvider>

</div>

Props

Interface ShapeLibraryPaletteComponentProps

NameTypeDescription
canvasStrokeWidth?numberStroke width to use for shapes dropped on canvas. Defaults to 2.
dataGenerator?DataGeneratorFunctionOptional data generator to allow you to specify initial data for some element to be dragged. Note that you cannot override the object's type with this function. The palette will set the new object's type to match the type of the element that the user is dragging from the palette.
dragSize?SizeOptional size to use for dragged elements.
fill?stringOptional fill color to use for dragged elements. This should be in RGB format, _not_ a color like 'white' or 'cyan' etc.
iconSize?SizeOptional size to use for icons.
initialSet?stringID of the initial set to show, if any. When you have multiple shapes in a set you may want the palette to open up showing just one set.
outline?stringOptional color to use for outline of dragged elements. Should be in RGB format.
paletteStrokeWidth?numberStroke width to use for shapes in palette. Defaults to 1.
selectAfterDrop?booleanWhen true (which is the default), a newly dropped vertex will be set as the underlying Toolkit's selection.
shapeLibrary?ShapeLibraryImplThe shape library to render.
showAllMessage?stringMessage to use for the 'show all' option in the shape set drop down when there is more than one set of shapes. Defaults to Show all.
surface?SurfaceSurface to attach the drag/drop to. Optional; this component can extract the Surface from a SurfaceProvider, or from being a child of a SurfaceComponent.

ShapeComponent

This component is used in conjunction with a ShapeLibrary to render SVG shapes.

Example

import * as React from 'react';

import { ShapeComponent } from "@jsplumbtoolkit/browser-ui-react"

export default function NodeComponent({ctx}) {

return <div className="my-class">
<ShapeComponent ctx={ctx} showLabels={true} labelProperty="text"/>
</div>
}

Props

Interface ShapeComponentProps

NameTypeDescription
ctxJsxWrapperPropsContext for the vertex, as passed in by the SurfaceComponent.
labelProperty?stringThe name of the property that identifies some vertex's label. Defaults to "label".
labelStrokeWidth?stringOptional stroke width to use for labels. Defaults to "0.25px".
showLabels?booleanDefaults to false. If true, a label will be written on the shape (using an SVG text element).

Skip to main content

Vue 2 Integration

JsPlumb Toolkit has several components to assist you in integrating with Vue 2. These are shipped in the package @jsplumbtoolkit/browser-ui-vue2.

Vue 2 versions of our Flowchart Builder and Schema Builder starter apps are available in the JsPlumb demonstrations organisation on Github.

info

We are in the process of deprecating our Vue 2 integration package, since Vue 2 reached EOL at the end of 2023.


Imports​

"dependencies":{
"@jsplumbtoolkit/browser-ui-vue2":"6.81.0"
}

Setup​

JsPlumb's Vue2 components are shipped with precompiled templates, meaning you need to import JsPlumb in your Vue bootstrap code. For instance, this is the bootstrap routine from the Flowchart demonstration:

Bootstrap​

import Vue from 'vue'
import App from './App.vue'

import { JsPlumbToolkitVue2Plugin } from '@jsplumbtoolkit/browser-ui-vue2' // <---- import the Toolkit Vue 2 plugin

Vue.use(JsPlumbToolkitVue2Plugin); // <-- instruct Vue to load the Toolkit plugin

new Vue({ render: h => h(App) }).$mount('#app')


Components​

JsPlumb offers 2 components and 3 mixins:

jsplumb-toolkit​

This component provides an instance of JsPlumb and a surface widget to render the contents.

Example​

<jsplumb-toolkit id="toolkit" surface-id="surfaceId" v-bind:render-params="anObjectReference" 
v-bind:toolkit-params="anObjectReference" v-bind:view="anObjectReference">
</jsplumb-toolkit>

Attributes​

All attributes are optional. Note that Vue prefers "kebab case" for attribute names, even if the actual property is camel case on the component (and of course Javascript does not like kebab case for property names).

  • id Unique ID for the Toolkit instance. Can be used to retrieve a Toolkit instance from the jsPlumbToolkitVue2 module.
  • surface-id Unique ID for the Surface widget. Required if you wish to attach a Miniview or a Palette. Also useful if you wish to interact with a Surface, to perform operations such as zooming, centering on content, etc.
  • render-params Parameters to pass in to the constructor of the Surface widget. Note here we use the v-bind: prefix to tell Vue that the object we are injecting is in the Vue instance's model.
  • toolkit-params Parameters to pass in to the constructor of the Toolkit instance. Note again the use of v-bind: in our example above.
  • view View parameters. Views are discussed here.

jsplumb-miniview​

This is a component that provides a miniview that can be attached to some surface.

Example​

<jsplumb-miniview surface-id="surfaceId"></jsplumb-miniview>

Attributes​

  • surface-id ID for the surface widget to which to attach the Miniview.

SurfaceDrop mixin​

This mixin is a wrapper around the Drop Manager, which offers the ability to drop onto edges, nodes and the canvas itself.

Example​

This is an example of a component that uses the SurfaceDrop mixin. We show, in the onCanvasDrop method, an example of how this mixin can be used to replace the previous Palette mixin. Note, though, the onEdgeDrop and onDrop methods: these are, respectively, called when an element is dragged on an Edge or a Node/Group.

<template>
<div class="sidebar node-palette">
<div class="sidebar-item" :data-node-type="entry.type" title="Drag to add new" v-for="entry in data" :key="entry.type">
<i :class="entry.icon"></i>{{entry.label}}
</div>
</div>
</template>

<script>

import { SurfaceDrop } from '@jsplumbtoolkit/browser-ui-vue2';

export default {
mixins:[ SurfaceDrop ],
data:function() {
return {
data:[
{ icon:"icon-tablet", label:"Question", type:"question" },
{ icon:"icon-eye-open", label:"Action", type:"action" },
{ type:"output", icon:"icon-eye-open", label:"Output" }
]
};
}
}

</script>

Note that this component itself doesn't declare any props, and you are free to provide any template you wish to render the component's data. The underlying DragDrop mixin's props are:

  • surfaceId:string Required. The ID of the Surface to which to attach the Drop Manager.
  • selector:string Required. A CSS3 selector instructing the Toolkit how to identify which elements in the component represent draggable node types.
  • dataGenerator:(el:HTMLElement) => T Optional. A function that can return a data object representing an element which is being dragged. This function is called as soon as an element starts to be dragged.
  • allowDropOnGroup:boolean Optional, defaults to true. If true, then elements can be dropped onto nodes/groups, and in the event that occurs, the onDrop method will be called.
  • allowDropOnCanvas:boolean Optional, defaults to true. When an element is dropped on the canvas whitespace, it is added to the dataset and rendered.
  • allowDropOnEdge:boolean Optional, defaults to true. If true, then elements can be dropped onto edges, and in the event that an element is dropped on an edge, a new node/group is added and inserted between the source and target of the original edge, and the original edge is discarded..
  • typeGenerator:(data:T) => string Optional. A function that can return the correct type for some data object representing an element being dragged. By default the Toolkit will use the type member of the data object.
  • groupIdentifier:(d: T, el: HTMLElement) => boolean Optional. By default, the toolkit looks for a jtk-is-group attribute on an element being dragged. If found, with a value of "true", then the Toolkit assumes a group is being dragged. You can supply your own function to make this decision.

BaseNodeComponent​

This mixin should be included in any component you will use to render a node (see below for discussion of this). Several helper methods are exposed by this mixin:

  • getNode() Gets the underlying Toolkit node that the component is rendering
  • removeNode() Instructs the Toolkit to remove the node that the component is rendering. This will of course result in the destruction of the component.
  • getToolkit() Gets the underlying Toolkit instance for the node the component is rendering.
  • updateNode(data:any) Updates the underlying node that the component is rendering.

Nodes rendered with this mixin are fully reactive: calls to updateNode will result in a repaint of the component with no further effort involved on your part.

BaseGroupComponent​

This mixin should be included in any component you will use to render a group (see below for discussion of this). Several helper methods are exposed by this mixin:

  • getGroup() Gets the underlying Toolkit group that the component is rendering
  • removeGroup(removeChildNodes?:boolean) Instructs the Toolkit to remove the group that the component is rendering, and possibly all of the child nodes of the group too. This will of course result in the destruction of the component.
  • getToolkit() Gets the underlying Toolkit instance for the group the component is rendering.
  • updateGroup(data:any) Updates the underlying group that the component is rendering.

Groups rendered with this mixin are fully reactive: calls to updateGroup will result in a repaint of the component with no further effort involved on your part.


Rendering Nodes and Groups​

To render nodes and groups you need to do 3 things:

  • create a component
  • import it into the code that's handling your Toolkit instance
  • map it via the view.

Imagine you make this component inside MyNode.vue:

<template>
<div>
<h1>{{obj.label}}</h1>
<button v-on:click="clicked()">CLICK ME</button>
</div>
</template>


<script>
import { BaseNodeComponent } from "@jsplumbtoolkit/browser-ui-vue2";

export default {
mixins:[ BaseNodeComponent ],
methods:{
clicked:function() {
alert(this.getNode().data.label);
}
}
}
</script>

And you make this component, to manage an instance of the Toolkit:

<template>
<jsplumb-toolkit
ref="toolkitComponent"
url="flowchart-1.json"
v-bind:render-params="renderParams"
v-bind:view="view"
id="toolkit"
surface-id="surface"
v-bind:toolkit-params="toolkitParams">
</jsplumb-toolkit>
</template>

<script>

import MyNode from './MyNode.vue';

export default {

name: 'jsp-toolkit',
props:["surfaceId"],
data:() => {
renderParams:{ ... },
view:{
nodes:{
default:{
component:MyNode
}
}
}
}
}
</script>

MyNode is mapped to the component used to render nodes of type "default" (which for the Toolkit means any node). The jsplumb-toolkit declaration in the template is the one from the Flowchart Builder, which is a good place to look to get a feel for how a whole application can be built using the Toolkit.

Injecting values into nodes/groups​

From version 5.13.7 onwards, you can provide a set of data values that you'd like to inject into a component via the inject property of a node definition:

export default {

name: 'jsp-toolkit',
props:["surfaceId"],
data:() => {
renderParams:{ ... },
view:{
nodes:{
default:{
component:MyNode,
inject:{
injectedStaticValue:"My Static Value",
injectedDynamicValue:(node, toolkit) => `My Dynamic Value ${node.id}`
}
}
}
}
}
}

Each value you inject can be either a static value, or a function that takes as argument the current node (or group) and the underlying Toolkit instance, and which returns an appropriate value.

In the component itself you need to declare these in the data section:

data:{
injectedStaticValue:String,
injectedDynamicValue:String
},

You can then access these values in your template:

<template>
<div class="injected-static">{{injectedStaticValue}}</div>
<div class="injected-dynamic">{{injectedDynamicValue}}</div>
</template>

Rendering Ports​

The Vue 2 integration supports rendering ports. A good example for how to do this can be found in the code for the Schema Builder starter application.


Shape Libraries​

A shape library is a set of named shapes that you will use to render SVG inside the vertices in your application. These are discussed in detail in the shape libraries page; here we provide an overview of the available Vue 2 integration with these modules.

The Vue 2 integration has a plugin to assist you working with shape libraries. To enable it, you need to import it in your setup:

import Vue from 'vue'
import App from './App.vue'

import { JsPlumbToolkitVue2Plugin, ShapeLibraryPlugin } from '@jsplumbtoolkit/browser-ui-vue2'

Vue.use(JsPlumbToolkitVue2Plugin); // <-- instruct Vue to load the Toolkit plugin
Vue.use(ShapeLibraryPlugin); // <-- instruct Vue to load the shape library plugin

new Vue({ render: h => h(App) }).$mount('#app')

Rendering shapes​

Once you've imported the shape library plugin, there will be jsplumb-shape component available to all of your components. In your main component - the one in which you declare your view - you need to instantiate a shape library, and then you need to inject it into each of your vertex components:


<script>

import { FLOWCHART_SHAPES, BASIC_SHAPES, ShapeLibraryImpl } from "@jsplumbtoolkit/browser-ui"

import MyVertexComponent from './MyVertexComponent.vue'

const shapeLibrary = new ShapeLibraryImpl([FLOWCHART_SHAPES, BASIC_SHAPES])

export default {
name:"flowchart",
...,
data:() => {
return {
renderParams:{ ... },
view:{
nodes:{
default:{
component:MyVertexComponent,
inject:{
shapeLibrary:shapeLibrary
}
}
}
}
}
}
}
</script>
<template>
<div>
<jsplumb-toolkit ref="toolkitComponent"
surface-id="surfaceId"
v-bind:render-params="renderParams"
v-bind:view="view">
</jsplumb-toolkit>
</div>
</template>

Anything inside the inject mapping for a component inside your view will be available as a class member on that component - above we injected our shape library.

Then inside your vertex components you can render shapes:

<script>

import { BaseNodeComponent } from '@jsplumbtoolkit/browser-ui-vue2'

export default {
mixins:[BaseNodeComponent]
}

</script>
<template>
<div>
<span>{{obj.text}}</span>
<jsplumb-shape :obj="obj" :shape-library="shapeLibrary"></jsplumb-shape>
</div>
</template>

Shape Library Palettes​

The shape library plugin also makes available a jsplumb-shape-palette component, which lets you drag and drop new shapes from a palette:

To use it, you need to have setup the shape library as shown above. Then, in your template:

<jsplumb-shape-palette surface-id="surfaceId"
:shape-library="shapeLibrary"
:data-generator="dataGenerator"
initial-set="flowchart"/>

Attributes​

  • surfaceId:string Required. The ID of the surface to which to attach the palette.
  • shapeLibrary:ShapeLibraryImpl Your shape library
  • dragSize:Size Optional size to set on elements when they are being dragged. If this is omitted, the derived iconSize will be used.
  • iconSize:Size Optional, defaults to 150x100 pixels. This is the size to use for each icon. It will also be used for dragSize if that is not separately specified.
  • fill:string Optional, defaults to "#FFFFFF". Fill color to use for icons.
  • outline:string Optional, defaults to "#000000". Color to use for icon outline.
  • selectAfterDrop:boolean Optional, defaults to true. Instructs the palette to set a newly dropped vertex as the Toolkit's selection.
  • canvasStrokeWidth:number Optional, defaults to 2. The stroke width to use when rendering dropped vertices on the canvas.
  • paletteStrokeWidth:number Optional, defaults to 1. The stroke width to use when rendering icons in the palette.
  • dataGenerator:DataGeneratorFunction Optional. Provide one of these if you wish to be able to set initial data for some icon that is about to be dragged on to the canvas.
  • initialSet If your shape library has multiple sets but when the palette is first rendered you want to specify a single set to show, set this value.

Skip to main content

JsPlumb Angular

JsPlumb has a service and several components/directives to assist you in integrating with Angular 16+. If you're running an earlier Angular version than 16, you'll need to use our legacy Angular integration.

Imports​

"dependencies":{
"@jsplumbtoolkit/browser-ui-angular":"6.81.0"
}

Setup​

You need to import the jsPlumbToolkitModule:

import { jsPlumbToolkitModule } from '@jsplumbtoolkit/browser-ui-angular';

...

@NgModule({
imports: [ BrowserModule, jsPlumbToolkitModule],
declarations: [ SomeComponent ],
bootstrap: [ SomeComponent ],
schemas:[ CUSTOM_ELEMENTS_SCHEMA ]
})
note

Be sure to import the CUSTOM_ELEMENTS_SCHEMA schema. Without this import you will not be able to map components to node/group types.


Quick start​

Here's a basic setup that uses the jsplumb-surface component to render a couple of nodes and an edge:


import {Component} from "@angular/core"

@Component({
template:`<div style={{width:"100%",height:"100%"}}>
<jsplumb-surface [data]="data"></jsplumb-surface>
<jsplumb-controls></jsplumb-controls>
<jsplumb-miniview></jsplumb-miniview>
</div>`
})
export class DemoComponent {

data = {
nodes:[
{ id:"1", label:"1", left:50, top:50},
{ id:"2", label:"TWO", left:250, top:250}
],
edges:[
{ source:"1", target:"2" }
]
}

}

In the above example the only attributes we set on the jsplumb-surface was data, meaning the component uses a default Absolute layout and a default Angular component for rendering nodes. The jsplumb-surface, though, is highly configurable, mainly through its view and renderParams inputs. Here's the same example from before but with a few more things configured, and an Angular component to render nodes with:

NodeComponent​

import {Component} from "@angular/core"

import { BaseNodeComponent } from '@jsplumbtoolkit/browser-ui-angular';

@Component({
template:`<div style={{width:"60px", height:"60px", backgroundColor:"white", border:"1px solid black", text-align:"center"}}>
<h3>{{obj.label}}</h3>
</div>`
})
export class NodeComponent extends BaseNodeComponent {

}
DemoComponent​

import {Component} from "@angular/core"

import { NodeComponent } from './node.component';

@Component({
template:`<div style={{width:"100%",height:"100%"}}>

<jsplumb-surface [data]="data"
[renderParams]="renderParams"
[view]="view"></jsplumb-surface>

<jsplumb-controls></jsplumb-controls>
<jsplumb-miniview></jsplumb-miniview>
</div>`
})
export class DemoComponent {

view = {
nodes:{
default:{
component:NodeComponent
}
}
}

data = {
nodes:[
{ id:"1", label:"1", left:50, top:50},
{ id:"2", label:"TWO", left:250, top:250}
],
edges:[
{ source:"1", target:"2" }
]
}

renderOptions = {
layout:{
type:"ForceDirected"
},
grid:{
size:{
w:50, h:50
}
}
}

}


Rendering Nodes and Groups​

At the core of your UI will be a jsplumb-surface, which provides the canvas onto which nodes, groups and edges are drawn. In the Quickstart section above we show a couple of examples of the jsplumb-surface in action.

Each node or group in your UI is rendered as an individual Angular component. In the first example above, we rely on JsPlumb's default Angular component to render each node, but in the second we provide a component ourselves, although its quite simple. In a real world app your component will likely be more complex, and can take full advantage of all the power that Angular offers. As an example, consider the component we use to render nodes in the Flowchart Builder:

import {Component} from "@angular/core"
import {BaseNodeComponent} from "@jsplumbtoolkit/browser-ui-angular"

import { anchorPositions } from "./app.component"

@Component({
template:`<div style="color:{{obj.textColor}}" class="flowchart-object" data-jtk-target="true">

<jtk-shape [obj]="obj" showLabels="true" labelProperty="text" [width]="obj.width" [height]="obj.height"></jtk-shape>

<div *ngFor="let anchor of anchorPositions"
class="jtk-connect jtk-connect-{{anchor.id}}"
[attr.data-jtk-anchor-x]="anchor.x"
[attr.data-jtk-anchor-y]="anchor.y"
[attr.data-jtk-orientation-x]="anchor.ox"
[attr.data-jtk-orientation-y]="anchor.oy"
data-jtk-source="true"></div>

<div class="node-delete node-action delete" (click)="this.removeNode()"></div>
</div>`
})
export class NodeComponent extends BaseNodeComponent {
anchorPositions = anchorPositions
}

The components you use to render nodes with JsPlumb Angular are entirely at your discretion, and can be as simple or as powerful as you like.

Mapping types to components​

The view input is used to map node/group types to components, and to certain behaviours. For instance, this is the nodes section of the view for the flowchart builder starter app:

view = {
nodes: {
[DEFAULT]:{
component:NodeComponent,
// target connections to this node can exist at any of the given anchorPositions
anchorPositions,
// node can support any number of connections.
maxConnections: -1,
events: {
[EVENT_TAP]: (params) => {
this.edgeEditor.stopEditing()
// if zero nodes currently selected, or the shift key wasnt pressed, make this node the only one in the selection.
if (this.toolkit.getSelection()._nodes.length < 1 || params.e.shiftKey !== true) {
this.toolkit.setSelection(params.obj)
} else {
// if multiple nodes already selected, or shift was pressed, add this node to the current selection.
this.toolkit.addToSelection(params.obj)
}
}
}
}
}
}

To map a node/group type to a component, you supply a reference to the component's class as the component in a mapping, as shown above.

Using @Input in a node/group component​

There are two approaches to injecting values into a node/group component.

Injecting values from the backing data​

Imagine the component shown above was being used to render some node type in your UI - with a couple of small changes we can make it so:

import {BaseNodeComponent} from "@jsplumbtoolkit/browser-ui-angular"
import {EventEmitter, Component, Input, Output} from "@angular/core"

@Component({
template:`
<div>
<h1>{{title}}</h1>
<button class="btnEmit" (click)="emitEvent('test')">Click Me</button>
</div>
`
})
export class NodeComponent extends BaseNodeComponent {
@Input() title:string

@Output() outputEvent = new EventEmitter<string>()

emitEvent(value:string) {
this.outputEvent.emit(value)
}
}

We've removed selector from the Component spec, since it's not relevant when rendering via the Surface, and we've wired up the component to extend BaseNodeComponent, but other than that the component is the same as in the first example.

JsPlumb will attempt to set this input from the backing data for the node. So if, for instance, you had this data object for a node:

{
"id": "1",
"title": "My First Node"
}

then JsPlumb will set "My First Node" on the title input. This is of course really just a form of syntactic sugar - you could just easily render the title in your template like this (remembering that obj is set on the component by the Toolkit when it creates it):

<h1>{{obj.title}}</h1>

as you can by using the input on the class:

<h1>{{title}}</h1>

but if you're like me, you might find that the approach using @Input feels a little more nicely formalised.

Injecting values from the view​

An alternative approach to injecting values from a node or group's backing data is to provide a string or a function inside of the view from which JsPlumb will get the value to use. Consider again the component from above:

import {BaseNodeComponent} from "@jsplumbtoolkit/browser-ui-angular"
import {EventEmitter, Component, Input, Output} from "@angular/core"

@Component({
template:`
<div>
<h1>{{title}}</h1>
<button class="btnEmit" (click)="emitEvent('test')">Click Me</button>
</div>
`
})
export class NodeComponent extends BaseNodeComponent {
@Input() title:string

@Output() outputEvent = new EventEmitter<string>()

emitEvent(value:string) {
this.outputEvent.emit(value)
}
}

We can map this component in our view and provide a function to populate title at render time:

view:{
nodes:{
default:{
component:NodeComponent,
inputs:{
title:(n:Node) => 'here you can return any string you like'
}
}
}
}

Using @Output in a node/group component​

You can also now wire up listeners to @Outputs in your components. The process to do this involves providing a vertexEvent callback to the Surface component. For example, imagine you embed a surface component in one of your components:

<div class="my-component">
<h3>Here is my component</h3>
<jsplumb-surface [view]="view"
[renderParams]="renderParams"
(vertexEvent)="vertexEvent($event)">
</jsplumb-surface>
</div>

Remember from above the @Output() outputEvent... declaration on the node component? Whenever that output emits something, the Surface will invoke vertexEvent:


import { Vertex } from "@jsplumbtoolkit/browser-ui"
import { ComponentRef } from "@angular/core"

vertexEvent(detail:{
vertex:Vertex,
event:Event,
payload:any,
component:ComponentRef<any>}) {

}

The callback is given JsPlumb's vertex, the original event, the payload (ie. whatever was emitted from the output), and the Angular ComponentRef. You can access the specific Angular component via the instance field on this component ref.


Rendering Ports​

Some applications whose data model use ports have a UI in which each Port is assigned its own DOM element. In the Flowchart Builder application we use ports in the data model (a question node, for instance, has a Yes and a No output port), but we do not assign a DOM element to each port. In the Schema Builder, though, we do: we model a database table as a node, and the columns on that table as ports, and each port is assigned its own DOM element:

Database Visualizer Table Node

Here we see three columns, each of which has a button by which it can be deleted, and a button that launches a column name editor. These two bits of behaviour are handled by the component backing the port.

Definition​

This is the definition of the component used to render columns on table nodes:


import { BasePortComponent } from "@jsplumbtoolkit/browser-ui-angular";

@Component({
selector:"db-column",
templateUrl:"templates/column.html"
})
export class ColumnComponent extends BasePortComponent {

constructor(el: ElementRef) {
super(el);
}

remove() { ... }

editName() { ... }
}

There are three requirements for a component to be used to render a port:

  • you must extend BasePortComponent
  • your constructor must accept an ElementRef and call the superclass constructor with it
  • you must declare a selector for the component

Template​

The component definition maps a templateUrl. This is what the template looks like in this example:

<div class="table-column table-column-type-{{obj.datatype}}"
attr.primary-key="{{obj.primaryKey}}" attr.data-jtk-port="{{obj.id}}"
data-jtk-source="true" attr.data-jtk-scope="{{obj.datatype}}" data-jtk-target="true">

<div class="table-column-delete" (click)="remove()">
<i class="fa fa-times table-column-delete-icon"></i>
</div>

<div><span>{{obj.name}}</span></div>

<div class="table-column-edit" (click)="editName()">
<i class="fa fa-pencil table-column-edit-icon"></i>
</div>

</div>

Mapping to a type​

You map components to port types in the view. Here's the ports section from the view in the Angular Database Visualizer application:

ports: {
"default": {
component: ColumnComponent,
paintStyle: { fill: "#f76258" }, // the endpoint's appearance
hoverPaintStyle: { fill: "#434343" }, // appearance when mouse hovering on endpoint or connection
edgeType: "common", // the type of edge for connections from this port type
maxConnections: -1, // no limit on connections
dropOptions: { //drop options for the port. here we attach a css class.
hoverClass: "drop-hover"
},
events: {
"dblclick": (p:any) => {
console.log(p);
}
}
}
}

Declaration​

You must declare each port component in the declarations member of your module definition. Here's the module definition for the Database Visualizer demonstration, for example:


import { DatabaseVisualizerComponent, TableNodeComponent, ViewNodeComponent, ColumnComponent } from './database-visualizer';

...

@NgModule({
imports:[ BrowserModule, jsPlumbToolkitModule, ROUTING],
declarations: [ AppComponent, TableNodeComponent, ViewNodeComponent, ColumnComponent, DatasetComponent, DatabaseVisualizerComponent ],
bootstrap: [ AppComponent ]
schemas:[ CUSTOM_ELEMENTS_SCHEMA ]
})

...

Here we see ColumnComponent listed in declarations (along with the components used to render the node types table and view).

Checklist​

  • Each of your port components extends BasePortComponent from JsPlumb Angular.
  • You reference the underlying data via the member obj in your component templates
  • Each of your components is declared in the declarations list in your module definition
  • You've mapped each expected port to a component in your view


Change Detection​

Default​

If you're using Angular's default change detection mechanism (ChangeDetectionStrategy.Default) then your node/group/port/overlay components will be automatically updated whenever an updateNode, updateGroup, updatePort or updateEdge method is called on the Toolkit.

OnPush​

If you'd prefer to use ChangeDetectionStrategy.OnPush, JsPlumb Angular can support that. The only requirement is that you need to inject a ChangeDetectorRef into any component with which you want to use OnPush change detection. For example, this is how we'd modify the ColumnComponent shown above to support OnPush change detection:


import { BasePortComponent } from "@jsplumbtoolkit/browser-ui-angular-legacy";

@Component({
changeDetection:ChangeDetectionStrategy.OnPush,
selector:"db-column",
templateUrl:"templates/column.html"
})
export class ColumnComponent extends BasePortComponent {

constructor(el: ElementRef, public changeDetectorRef:ChangeDetectorRef) {
super(el)
}

remove() { ... }

editName() { ... }
}

NOTE you must use the name changeDetectorRef for this constructor parameter, and you must also mark it public. JsPlumb discovers the change detector by name, not by type.

This also works for node/group components.


Shape libraries​

A shape library is a set of named shapes that you will use to render SVG inside the vertices in your application. These are discussed in detail in the shape libraries and shape-sets pages; here we provide an overview of the available Angular integration with these modules.

Creating a shape library​

In Angular, a shape library is created by registering one on the jsPlumbService:

import {Component} from '@angular/core';
import { FLOWCHART_SHAPES, BASIC_SHAPES } from "@jsplumbtoolkit/browser-ui";

@Component({
selector: 'app-root',
templateUrl: './app.component.html'
})
export class AppComponent {

constructor(public $jsplumb: jsPlumbService) {
this.$jsplumb.registerShapeLibrary([FLOWCHART_SHAPES, BASIC_SHAPES]);
}

}

Here, we've injected jsPlumbService into our component, and then invoked registerShapeLibrary on it, to register our shape library. Note that we did not provide any identifier for our shape library in the above code; if your app has only only shape library you do not need to provide an id, as JsPlumb will use a default. But if you had more than one shape library you'd want to provide an id when registering them:

import {Component} from '@angular/core';
import { FLOWCHART_SHAPES, BASIC_SHAPES } from "@jsplumbtoolkit/browser-ui";

@Component({
selector: 'app-root',
templateUrl: './app.component.html'
})
export class AppComponent {

constructor(public $jsplumb: jsPlumbService) {
this.$jsplumb.registerShapeLibrary([BASIC_SHAPES], "basic");
this.$jsplumb.registerShapeLibrary([FLOWCHART_SHAPES], "flowchart");
}

}

Rendering an SVG shape​

Shapes can be rendered with a jtk-shape. For example, here'a NodeComponent that we've mapped in our view, as shown above. This NodeComponent uses a jtk-shape inside its template:

import {Component} from "@angular/core"
import {BaseNodeComponent} from "@jsplumbtoolkit/browser-ui-angular"

@Component({
template:`<div style="color:{{obj.textColor}}" class="flowchart-object" data-jtk-target="true">
<jtk-shape [obj]="obj" [width]="obj.width"
[height]="obj.height"></jtk-shape>
</div>`
})
export class NodeComponent extends BaseNodeComponent { }

width, height and obj are all required inputs.

Again note the we did not tell the jtk-shape component how to find the shape library to use - it will use the default id. But if we wanted to specify a shape library, we'd do that with the shapeLibraryId input:

import {Component} from "@angular/core"
import {BaseNodeComponent} from "@jsplumbtoolkit/browser-ui-angular"

@Component({
template:`<div style="color:{{obj.textColor}}" class="flowchart-object" data-jtk-target="true">
<jtk-shape [obj]="obj" [width]="obj.width"
[height]="obj.height"
shapeLibraryId="basic"
></jtk-shape>
</div>`
})
export class NodeComponent extends BaseNodeComponent { }

Supported props​

The list of props support by the jtk-shape component is:

InputTypeDescription
shapeLibraryIdstringThe ID of the shape library to use. If not specified, a default will be used, which suffices for applications that are only using one shape library.
objObjectDataThe data for the vertex to render. Required.
widthnumberCurrent width for the shape. Although it may seem counterintuitive, this is required - you'll need to set it to `[width]="obj.width"`. Angular's change detection will not pick up changes to this otherwise.
heightnumberCurrent height. See notes for `width`.
showLabelsbooleanWhether or not to show labels.
labelPropertystringDefaults to `label`. The name of the property inside each vertex that contains its label.
labelStrokeWidthstringThe stroke width to use for labels. Optional. Defaults to the Toolkit's default.

By default the shape component will render just the shape. If you want to add labels you can do so like this:

import {Component} from "@angular/core"
import {BaseNodeComponent} from "@jsplumbtoolkit/browser-ui-angular"

@Component({
template:`<div style="color:{{obj.textColor}}" class="flowchart-object" data-jtk-target="true">

<jtk-shape [obj]="obj" showLabels="true"
[width]="obj.width"
[height]="obj.height"></jtk-shape>
</div>`
})
export class NodeComponent extends BaseNodeComponent { }

By default, JsPlumb will extract the label from a label property in your vertex data. You can provide the name of the property to use if you want to, by setting the labelProperty on your jtk-shape:

import {Component} from "@angular/core"
import {BaseNodeComponent} from "@jsplumbtoolkit/browser-ui-angular"

@Component({
template:`<div style="color:{{obj.textColor}}" class="flowchart-object" data-jtk-target="true">

<jtk-shape [obj]="obj" showLabels="true"
labelProperty="text"
[width]="obj.width"
[height]="obj.height"></jtk-shape>
</div>`
})
export class NodeComponent extends BaseNodeComponent { }

Adding your own shapes​

To add your own shapes, you'll need to create a shape set. These are discussed on a separate page.

Exporting a Surface to SVG/PNG/JPG​

It is possible to export a Surface that is using a shape library to SVG, PNG or JPG. For a full discussion of this, see this page. For convenience, we added several methods to our Angular integration to support this, as discussed below.

The methods are:

  • exportSvg<T extends ObjectData>(options:AngularSvgExportOptions<T>)

Exports a given surface to an SVG.

  • showSvgExportUI<T extends ObjectData>(options:AngularSvgExportUIOptions<T>)

Shows the Toolkit's SVG export UI

  • exportImage<T extends ObjectData>(options:AngularImageExportOptions<T>, onready:ImageReadyFunction)

Exports a given surface to an image (PNG or JPG)

  • showImageExportUI<T extends ObjectData>(options:AngularImageExportUIOptions<T>)

Shows the Toolkit's image export UI

  • exportPNG<T extends ObjectData>(options:AngularImageExportOptions<T>, onready:ImageReadyFunction)

Exports a given surface to a PNG

  • exportJPG<T extends ObjectData>(options:AngularImageExportOptions<T>, onready:ImageReadyFunction)

Exports a given surface to a JPG

There are four interfaces used by these methods - AngularSvgExportOptions, AngularImageExportOptions, AngularSvgExportUIOptions and AngularImageExportUIOptions. Each of these is an extension of an interface from the exporter, and each of these interfaces has these properties in common:

 /**
* Surface to export
*/
surface:Surface
/**
* Optional ShapeLibrary to use. If not supplied, supply `shapeLibraryId` - or ensure the Surface you are exporting has a ShapeLibrary registered on it.
*/
shapeLibrary?:ShapeLibrary<T>
/**
* Optional ID of a ShapeLibrary to use - must have been registered on the jsPlumb Angular service via the `registerShapeLibrary` method. If not supplied,
* supply `shapeLibrary` - or ensure the Surface you are exporting has a ShapeLibrary registered on it.
*/
shapeLibraryId?:string

The key piece to keep in mind when exporting via Angular is that your Surface most likely does not have a shape library registered directly on it, due to the way shape libraries and surface are created when using the Angular integration.

We recommend you always register a shape library on the Angular service, which you can then retrieve via its ID, and provide as shapeLibraryId to one of the export calls. But keep in mind that if you're only using one shape library, you can register it without an id and the Toolkit will use a default - and it will also use that default ID when trying to retrieve a shape library to use for an export.

For example, this is from the flowchart builder starter pp:

exportSVG() {
// use the `showSvgExportUI` method to popup the exporter window. Note that we do not need to provide a shapeLibrary
// shapeLibraryId here, as the service will use a default shape library id if none is provided. We also did not provide an
// id when we registered the shape library above, meaning it was registered with the default id.
this.$jsplumb.showSvgExportUI({
surface:this.surface
})
}

Dragging new nodes/groups​

Palettes offer a means for your users to drag new nodes/groups onto your canvas. The SurfaceDropComponent allows you to configure drag/drop of HTML elements; there's also a ShapeLibraryPaletteComponent which is a specialised version of the SurfaceDropComponent that sources its draggable nodes from a ShapeLibrary.

HTML elements​

To configure your UI to drag and drop HTML elements onto your canvas, you'll use a SurfaceDropComponent, which is a directive you declare via the inclusion of a specific attribute on some element in your template:

<div class="sidebar node-palette" 
jsplumb-surface-drop
selector="div"
[dataGenerator]="dataGenerator">
<div *ngFor="let nodeType of nodeTypes"
[attr.data-node-type]="nodeType.type"
[attr.jtk-width]="nodeType.w"
[attr.jtk-height]="nodeType.h">{{nodeType.label}}</div>
</div>

The basic contract is that you declare the jsplumb-surface-drop attribute on some element, identifying it as a SurfaceDropComponent. You also need to specify the selector, which tells JsPlumb how to locate child elements that should be draggable. In the code above we used div, but any valid CSS3 selector may be used.

The SurfaceDropComponent also needs to know which surface to attach to. You can provide a surfaceId input to identify your surface, but if you do not, JsPlumb will use the default ID. For the vast majority of apps - having only a single surface - you can safely omit the surfaceId and use the default.

In the code above we also see a dataGenerator input: dataGenerator provides a means for the component to generate an initial data payload for some node that is being dragged:

export class AppComponent {

dataGenerator(el:Element) {
return {
type:el.getAttribute("data-node-type"),
width:parseInt(el.getAttribute("jtk-width"), 10),
height:parseInt(el.getAttribute("jtk-height"))
}
}

}

List of inputs​

InputTypeDescription
surfaceIdstringID of the surface to attach to. Only required if you have more than one surface in your UI.
selectorstringCSS3 selector identifying child elements that represent draggable nodes.
dataGeneratorDataGeneratorFunctionFunction to use to generate an initial payload when the user starts to drag something from this component. Optional but you should almost certainly consider providing this, or a `typeGenerator`, since without one of these it is not possible to determine the type of object beind dragged.
typeGeneratorTypeGeneratorFunctionOptional function to use to determine the type of object that a user has just started dragging
groupIdentifierFunctionGroupIdentifierFunctionOptional function to use to determine if the object that is being dragged represents a group. If this function is present, and returns true, then the drag object is considered to be a group. In all other cases the drag object is considered to be a node.
canvasSelectorstringOptional extra selector to use when dragging to identify parts of the surface's canvas that should be considered whitespace. If you use a decorator, for instance, or have otherwise positioned elements on your canvas, these elements will not by default be considered whitespace.
allowDropOnEdgebooleanDefaults to true. Allows items to be dropped onto edges in the canvas.
allowDropOnGroupbooleanDefaults to true. Allows items to be dropped onto groups in the canvas.
allowDropOnCanvasbooleanDefaults to true. Allows items to be dropped onto whitespace.
allowDropOnNodebooleanDefaults to false. Allows items to be dropped onto nodes in the canvas. If this is true and an element is dropped onto a node, the result is the same as if the element has been dropped onto whitespace.

SVG shapes​

To drag and drop SVG shapes, you can use a ShapeLibraryPaletteComponent. This is a specialised version of the PaletteComponent which sources its draggable nodes from a ShapeLibrary. Unlike SurfaceDropComponent this is not a directive - it's an element you drop into your template:

@Component({
selector:"app-component",
template:`<div>
<jsplumb-surface [view]="view"></jsplumb-surface>
<jtk-shape-palette [dataGenerator]="dataGenerator"></jtk-shape-palette>
</div>`
</div>
})

export class AppComponent {
view = {... }

dataGenerator(el:Element) {
return {
...
}
}
}

dataGenerator is optional. JsPlumb will create a data object containing the type and category of any shape you drag; if you choose to provide a dataGenerator your values will be added to the data object JsPlumb creates.

note

You cannot override type or category via a dataGenerator. JsPlumb will use the values corresponding to the shape that was dragged

As with the SurfaceDropComponent, in the code shown we have not supplied a surfaceId, and this is again because the component will use a default when a value is not supplied.

InputTypeDescription
shapeLibraryIdstringThe ID of the shape library to render. If not specified, a default will be used, which suffices for applications that are only using one shape library. Defaults to `DEFAULT_SHAPE_LIBRARY_ID`
surfaceIdstringThe ID of the surface to attach to. Only required if you have more than one surface in your ui.
initialSetstringWhen the shape library contains multiple sets, use this to instruct the palette that you want it to initially load just displaying this set. Optional.
dragSizeSizeOptional size to use for dragged elements. Defaults to { w:150, h:100 }
iconSizeSizeOptional size to use for icons. Default to { w:150, h:100 }
fillstringOptional fill color to use for dragged elements. This should be in RGB format, _not_ a color like 'white' or 'cyan' etc.
outlinestringOptional color to use for outline of dragged elements. Should be in RGB format.
showAllMessagestringMessage to use for the 'show all' option in the shape set drop down when there is more than one set of shapes. Defaults to `Show all`.
selectAfterDropbooleanWhen true (which is the default), a newly dropped vertex will be set as the underlying Toolkit's selection.
canvasStrokeWidthnumberStroke width to use in shapes on the canvas. Defaults to 2.
paletteStrokeWidthnumberStroke width to use in shapes in the palette. Defaults to 1.
dataGeneratorDataGeneratorFunctionOptional function you can use to set some initial data for an element being dragged. Note that you cannot override the object's `type` with this function.

Using the jsPlumb Service​

At the core of JsPlumb's Angular integration is the jsPlumbService, which offers access to, and management of, JsPlumb Toolkit instances and surfaces. It is recommended to create an instance of JsPlumb programmatically at the top level of your application, which you can then share between different components. For instance, this is the ngOnInit method of the top level component in the Flowchart Builder demonstration:

export class AppComponent {

@ViewChild(FlowchartComponent) flowchart:FlowchartComponent;
@ViewChild(DatasetComponent) dataset:DatasetComponent;

toolkitId:string;
toolkit:jsPlumbToolkit;

constructor(private $jsplumb: jsPlumbService, private elementRef: ElementRef, private flowchartService: FlowchartService) {
this.toolkitId = this.elementRef.nativeElement.getAttribute('toolkitId');
}

ngOnInit() {
this.toolkit = this.$jsplumb.getToolkit(this.toolkitId, this.toolkitParams)
}

...
}

Retrieving Toolkits and Surfaces​

  • getToolkit(id:string, params?:jsPlumbToolkitOptions)

Either retrieves an existing Toolkit with the given ID, or creates a Toolkit instance and returns it. Options for the Toolkit instance may be passed in as the second argument; these are ignored if a Toolkit with the given ID already exists.

  • getSurface(id:string, callback:(surface:Surface)=>void, _params:SurfaceOptions)

Either retrieves the Surface with the given ID, or creates one, with the given Surface options, and returns it. The second argument to this method is a callback function - it is asynchronous, not returning the Surface until it has been initialised fully.

Storing/retrieving data​

  • store<T>(key:string, value:T)

Offers a means to store arbitrary data on the service, for retrieval elsewhere in your app.

  • retrieve<T>(key:string):T

Offers a means to retrieve arbitrary data from the service, which you have stored elsewhere in your app.

Working with Shape Libraries​

See above for a full discussion of how to work with shape libraries in Angular.

  • registerShapeLibrary<T = ObjectData>(shapeSets:Array<ShapeSet>, key?:string):void

Registers a shape library with the given id

  • retrieveShapeLibrary<T = ObjectData>(key?:string):ShapeLibraryImpl<T>

Retrieves the shape library with the given id

  • exportSvg<T extends ObjectData>(options:AngularSvgExportOptions<T>)

Exports a given surface to an SVG.

  • showSvgExportUI<T extends ObjectData>(options:AngularSvgExportUIOptions<T>)

Shows the Toolkit's SVG export UI

  • exportImage<T extends ObjectData>(options:AngularImageExportOptions<T>, onready:ImageReadyFunction)

Exports a given surface to an image (PNG or JPG)

  • showImageExportUI<T extends ObjectData>(options:AngularImageExportUIOptions<T>)

Shows the Toolkit's image export UI

  • exportPNG<T extends ObjectData>(options:AngularImageExportOptions<T>, onready:ImageReadyFunction)

Exports a given surface to a PNG

  • exportJPG<T extends ObjectData>(options:AngularImageExportOptions<T>, onready:ImageReadyFunction)

Exports a given surface to a JPG

ImageReadyFunction​

This function has the type:

type ImageReadyFunction = (params:{width:number, height:number, url:string, el:SVGElement, contentType:string}) => any
  • height Computed height for the image, in pixels.
  • width Computed width for the image, in pixels.
  • url A data url for the image, encoded as base 64.
  • el The underlying SVG element that was exported to the image
  • contentType eg image/png, image/jpeg.

Component List​

This is a full list of the components that are available in JsPlumb Angular. For each we provide a sample usage, which does not necessarily use all of the inputs available for the given component. We then provide the full list of available inputs.

SurfaceComponent​

The key UI component you'll use to render your UI.

<jsplumb-surface [renderParams]="renderParams" [view]="view"></jsplumb-surface>
Class:SurfaceComponent
Selector: jsplumb-surface
Inputs:
InputTypeDescription
surfaceIdstringID to use for the created surface. If you do not provide this a default value will be used. You only need to provide this if you are rendering a JsPlumb instance to more than one surface.
toolkitIdstringID of the Toolkit to which to attach the surface. If you do not provide this a default value will be used. You only really need to provide this if your page has more than one instance of JsPlumb.
viewAngularViewOptionsOptions for the view - mappings of components and behaviour to model object types.
renderParamsAngularRenderOptionsOptions for the underlying surface widget.
toolkitParamsJsPlumbToolkitOptionsOptional parameters for the underlying Toolkit. These will be used only if the Toolkit instance with the given ID has not yet been created somewhere else in the app.
runInsideAngularbooleanSet this to false if you do not want the Surface to set itself up inside a `runOutsideAngular` call. We do not recommend this. When the Surface setup is run inside Angular all of the event bindings from the surface's pan/zoom/drag handlers are piped through Angular, causing change detection events, which can result in a performance hit. We've only added this in case there is an unforeseen backwards compatibility issue in someone's app, but all of our testing of this change suggests that is unlikely.

MiniviewComponent​

Provides a Miniview of the contents of some surface.

Example​


import {Component} from "@angular/core"

@Component({
selector:"demo-component",
template:`<div style={{width:"100%",height:"100%"}}>
<jsplumb-surface [data]="data"></jsplumb-surface>
<jsplumb-miniview></jsplumb-miniview>
</div>`
})
export class DemoComponent {
data = { ... }
}

Class:MiniviewComponent
Selector: jsplumb-miniview
Inputs:
InputTypeDescription
surfaceIdstringID of the surface to attach the miniview to. Only required if you have more than one surface in your UI.
elementFilterFunctionOptional filter to determine whether or not include a given vertex in the miniview
typeFunctionFunctionOptional function to determine a `type` for each vertex, which is then written as an attribute onto the DOM element representing the vertex in the miniview.
activeTrackingbooleanWhether or not to move miniview elements at the same time as their related surface element is being dragged. Defaults to true.
clickToCenterbooleanDefaults to true, meaning a click on a node/group in the miniview will cause that node/group to be centered in the related surface.

ControlsComponent​

Provides a component that offers a set of controls for some surface.

Example​


import {Component} from "@angular/core"

@Component({
selector:"demo-component",
template:`<div style={{width:"100%",height:"100%"}}>
<jsplumb-surface [data]="data"></jsplumb-surface>
<jsplumb-controls></jsplumb-controls>
</div>`
})
export class DemoComponent {
data = { ... }
}

Class:ControlsComponent
Selector: jsplumb-controls
Inputs:
InputTypeDescription
surfaceIdstringID of the surface to attach the controls to. Only required if you have more than one surface in your UI.
undoRedobooleanDefaults to true. Whether or not to show undo/redo buttons.
zoomToExtentsbooleanDefaults to true. Whether or not to show the 'zoom to extents' button
clearbooleanDefaults to true. Whether or not to show the clear button.
clearMessagestringThe message to prompt the user with when they press the clear button. Defaults to 'Clear dataset?'
buttonsControlsComponentButtons[]Optional array of extra buttons to include. See controls component docs.
orientation'row'|'column'Defaults to 'row'.

SurfaceDropComponent​

This directive provides a means for you to configure the ability to drag/drop nodes and groups from some part of your UI into the canvas.

Class:SurfaceDropComponent
Selector: [jsplumb-surface-drop]
Inputs:
InputTypeDescription
surfaceIdstringID of the surface to attach to. Only required if you have more than one surface in your UI.
selectorstringCSS3 selector identifying child elements that represent draggable nodes.
dataGeneratorDataGeneratorFunctionFunction to use to generate an initial payload when the user starts to drag something from this component. Optional but you should almost certainly consider providing this, or a `typeGenerator`, since without one of these it is not possible to determine the type of object beind dragged.
typeGeneratorTypeGeneratorFunctionOptional function to use to determine the type of object that a user has just started dragging
groupIdentifierFunctionGroupIdentifierFunctionOptional function to use to determine if the object that is being dragged represents a group. If this function is present, and returns true, then the drag object is considered to be a group. In all other cases the drag object is considered to be a node.
canvasSelectorstringOptional extra selector to use when dragging to identify parts of the surface's canvas that should be considered whitespace. If you use a decorator, for instance, or have otherwise positioned elements on your canvas, these elements will not by default be considered whitespace.
allowDropOnEdgebooleanDefaults to true. Allows items to be dropped onto edges in the canvas.
allowDropOnGroupbooleanDefaults to true. Allows items to be dropped onto groups in the canvas.
allowDropOnCanvasbooleanDefaults to true. Allows items to be dropped onto whitespace.
allowDropOnNodebooleanDefaults to false. Allows items to be dropped onto nodes in the canvas. If this is true and an element is dropped onto a node, the result is the same as if the element has been dropped onto whitespace.

ShapeLibraryPaletteComponent​

Provides a palette that renders a shape library, from which new vertices can be dragged onto a surface.

Class:ShapeLibraryPaletteComponent
Selector: jtk-shape-library
Inputs:
InputTypeDescription
shapeLibraryIdstringThe ID of the shape library to render. If not specified, a default will be used, which suffices for applications that are only using one shape library. Defaults to `DEFAULT_SHAPE_LIBRARY_ID`
surfaceIdstringThe ID of the surface to attach to. Only required if you have more than one surface in your ui.
initialSetstringWhen the shape library contains multiple sets, use this to instruct the palette that you want it to initially load just displaying this set. Optional.
dragSizeSizeOptional size to use for dragged elements. Defaults to { w:150, h:100 }
iconSizeSizeOptional size to use for icons. Default to { w:150, h:100 }
fillstringOptional fill color to use for dragged elements. This should be in RGB format, _not_ a color like 'white' or 'cyan' etc.
outlinestringOptional color to use for outline of dragged elements. Should be in RGB format.
showAllMessagestringMessage to use for the 'show all' option in the shape set drop down when there is more than one set of shapes. Defaults to `Show all`.
selectAfterDropbooleanWhen true (which is the default), a newly dropped vertex will be set as the underlying Toolkit's selection.
canvasStrokeWidthnumberStroke width to use in shapes on the canvas. Defaults to 2.
paletteStrokeWidthnumberStroke width to use in shapes in the palette. Defaults to 1.
dataGeneratorDataGeneratorFunctionOptional function you can use to set some initial data for an element being dragged. Note that you cannot override the object's `type` with this function.

ShapeLibraryComponent​

Provides a means to render an SVG shape into a component.

Class:ShapeLibraryComponent
Selector: jtk-shape
Inputs:
InputTypeDescription
shapeLibraryIdstringThe ID of the shape library to use. If not specified, a default will be used, which suffices for applications that are only using one shape library.
objObjectDataThe data for the vertex to render. Required.
widthnumberCurrent width for the shape. Although it may seem counterintuitive, this is required - you'll need to set it to `[width]="obj.width"`. Angular's change detection will not pick up changes to this otherwise.
heightnumberCurrent height. See notes for `width`.
showLabelsbooleanWhether or not to show labels.
labelPropertystringDefaults to `label`. The name of the property inside each vertex that contains its label.
labelStrokeWidthstringThe stroke width to use for labels. Optional. Defaults to the Toolkit's default.